#
#	Tick Timer 2 interrupt handler
#	@(#)MTG-Ethernet:tickint.s	9.1	91/06/01
#

	ident	"@(#)MTG-Ethernet:tickint.s	5.1	90/03/19"

	set	tctr2,	0xfffe1000 + 23	# Tick Timer 2 Interrupt Control Reg.
	set	ticr2,	0xfffe1000 + 26	# Tick Timer 2 Interrupt Control Reg.
	set	tcr2,	0xfffe1000 + 27	# Tick Timer 2 Control Register
	set	ilev_6,	0x600		# Mask for level 6 interrupts
	set	Cpush,	0x40c0
	set	Cpop,	0x0302

	set	utick_per_tick,	10
	lcomm	utick_del,	64	# array of microtick delays
	global	utick_del
	global	mtg_tint		# vector address 124

	text
mtg_tint:
#	cmp.b	(tctr2),&0xffff			# are we going to overflow ?
#	beq.b	mtg_tint			# if yes, wait

	move.l	%d0, -(%sp)			# push %d0
	move.b	(tcr2), %d0			# save overflow count
	move.b	&0x7, (tcr2)			# clear overflow count
	lsr.l	&4, %d0				# update microtick
	and.l	&0xf, %d0
	add.l	%d0, ([mtg_utick])
	add.l	&1, (%d0.l*4,utick_del)		# register delay statistics
	sub.l	%d0, wait_for_tick		# is it time for tick ?
	move	%sr, -(%sp)			# push status register
	bgt.b	notick				# if >0 it's not time for tick

	add.l	&utick_per_tick, wait_for_tick	# call me again when it's time
notick:
	move.b	(ticr2), %d0			# clear interrupt
	move.b	%d0, (ticr2)
#	or	&ilev_6, %sr			# and lower interrupt mask
	move	(%sp)+, %sr			# pop status register
	bgt.b	utick_rts			# if >0 it's not time for tick

	addq.l	&1, ([mtg_sem])			# increment semaphore
	bne	utick_rts			# if not 0, return
	movm.l	&Cpush,	-(%sp)
	move.l	mtg_head, -(%sp)
	jsr	mtg_scan			# call mtg_scan (mtg_head)
	addq.l	&4, %sp
	movm.l	(%sp)+,	&Cpop
utick_rts:
	move.l	(%sp)+	,%d0			# pop %d0
	rte
